Attribute VB_Name = "Tools"
''''
'''' Erik Olson's VB Toolkit
'''' (Public Domain Source Code)
''''
''''

' For CALC
DefSng A-Z
Private Token$, TokenType, p#, Arg$ ' Used by the CALC function.

' For PUSH and POP
Private ArgStackPointer%
Dim ArgStack$(32)



Public Function StrTok(txt As String, Delimiter As String) As String
    If InStr(txt, Delimiter) Then
        StrTok = Left(txt, InStr(txt, Delimiter) - 1)
        txt = Mid(txt, InStr(txt, Delimiter) + 1)
    Else
        StrTok = txt
        txt = ""
    End If
End Function

Public Function InStrRev(MainString As String, FindString As String) As Integer
On Error Resume Next
    If MainString = "" Or FindString = "" Or Len(FindString) > Len(MainString) Then
        InStrRev = 0: Exit Function
    End If
    
    For x = Len(MainString) - Len(FindString) To 1 Step -1
        If Mid$(MainString, x, Len(FindString)) = FindString Then
            InStrRev = x: Exit Function
        End If
    Next x

End Function

Function dnow$()
On Error Resume Next
'               "MM/DD/YY"              Current date
N$ = Date$
N$ = replace$("-", "/", N$)
N$ = Left$(N$, 6) + Right$(N$, 2)
dnow$ = N$
End Function

Public Function fixdate$(x$)
On Error Resume Next
        Area$ = "FIXDATE"
    flag = 0
    x$ = ReplaceAny$("\- .:;,", "///////", x$)
        For y = 1 To Len(x$): If Mid$(x$, y, 1) = "/" Then Z = Z + 1
        Next y
        If Z <> 2 Then Exit Function

        M$ = Left$(x$, InStr(x$, "/") - 1)
        D$ = Mid$(x$, InStr(x$, "/") + 1)
        D$ = Left$(D$, InStr(D$, "/") - 1)
        yy$ = Mid$(x$, InStr(InStr(x$, "/") + 1, x$, "/") + 1)
        If Len(yy$) = 2 Then yy$ = "19" + yy$
        If Len(D$) = 1 Then D$ = "0" + D$
        If Len(M$) = 1 Then M$ = "0" + M$
        fixdate$ = yy$ + M$ + D$
End Function


Public Function DaysApart(ByVal DateFrom$, ByVal DateTo$)
On Error Resume Next
    Area$ = "DAYS APART"
  
  ' Returns the number of days between the two dates
  ' This function is aware of leap years
  ' No modifications are made to either Date

  ' Requires Dates to be in "YYYYMMDD" (Year,Month,Day) Format
  ' Requires FUNCTION ValidDate
  ' Requires FUNCTION DaysInMonth

  ' Example: Print DaysApart("19930101","19940101") prints to the screen 365
  ' Example: Print DaysApart("19920101","19930101") prints to the screen 366
  '                                                      1992 was a Leap Year
  DaysApart = 0
  Days = 0

  If Not (ValidDate(DateFrom$)) Or _
     Not (ValidDate(DateTo$)) Or _
     Val(DateFrom$) >= Val(DateTo$) Then Exit Function

  FY = Val(Left$(DateFrom$, 4))                'From Year
  FM = Val(Mid$(DateFrom$, 5, 2))              '     Month
  FD = Val(Right$(DateFrom$, 2))               '     Day

  TY = Val(Left$(DateTo$, 4))                  'To   Year
  TM = Val(Mid$(DateTo$, 5, 2))                '     Month
  TD = Val(Right$(DateTo$, 2))                 '     Day

  Do
    FD = FD + 1
    Days = Days + 1
    If FD > DaysInMonth(FY, FM) Then
      FM = FM + 1
      FD = 1
      If FM > 12 Then
        FY = FY + 1
        FM = 1
      End If
    End If
  Loop Until FY = TY And FM = TM And FD = TD

  DaysApart = Days

 End Function


Public Function DaysInMonth(ByVal Year, ByVal Month)
On Error Resume Next
Area$ = "DAYSINMONTH"
  ' Returns the number of Days in the Month
  ' No modifications are made to Year or Month
  ' Year info must be in full ie. 1993 NOT 93
  ' This function is aware of leap years

  ' Example PRINT DaysInMonth(1993,2) prints to the screen 28
  ' Example PRINT DaysInMonth(1992,2) prints to the screen 29
  '                                            1992 was a Leap Year

  DaysInMonth = 0

  If Year < 1000 Then Exit Function

  Select Case Month
    Case 2
      If (Year / 4) - Fix(Year / 4) = 0 Then      'Leap Year
        DaysInMonth = 29
      Else                                        'Non-Leap Year
        DaysInMonth = 28
      End If
    Case 4, 6, 9, 11
      DaysInMonth = 30
    Case Else
      DaysInMonth = 31
  End Select

 End Function



Public Function ValidDate(ByVal DateCheck$)
On Error Resume Next
Area$ = "VALID DATE"
  ' Returns True if Valid Date, False if not
  ' No modifications are made to DateCheck$
  ' This function is aware of leap years

  ' Requires DateCheck$ to be in "YYYYMMDD" (Year,Month,Day) Format
  ' Requires FUNCTION DaysInMonth

  ValidDate = 0

  If Len(DateCheck$) <> 8 Then Exit Function                'Check full date

  If Val(Left$(DateCheck$, 4)) > 999 And Val(Left$(DateCheck$, 4)) < 10000 Then

    If Val(Mid$(DateCheck$, 5, 2)) > 0 And Val(Mid$(DateCheck$, 5, 2)) < 13 Then

      If Val(Right$(DateCheck$, 2)) > 0 And Val(Right$(DateCheck$, 2)) <= DaysInMonth(Val(Left$(DateCheck$, 4)), Val(Mid$(DateCheck$, 5, 2))) Then

        ValidDate = -1

      End If
    End If
  End If

 
 End Function

Public Function decrypt$(a$)
    On Error Resume Next
    x = 1
    For y = 1 To Len(a$)
       x = x + 1 ' x goes from 1 to 4
       If x = 5 Then x = 1
        B$ = B$ + Chr$((Asc(Mid$(a$, y, 1)) - x) - 127)
    Next y
decrypt$ = B$
   
End Function

Public Function DirExist%(ByVal Spec$)
On Error Resume Next
DirSpec$ = Spec$
If (DirSpec$ = "\") Or _
   (Len(DirSpec$) = 3 And _
    Mid$(DirSpec$, 2, 1) = ":" And _
    Right$(DirSpec$, 1) = "\") Then
   DirExist% = -1
Else
   If Right$(DirSpec$, 1) = "\" Then
      DirSpec$ = Left$(DirSpec$, Len(DirSpec$) - 1)
   End If
   F$ = Dir$(DirSpec$, 0)
   If F$ = "" Then
      F$ = Dir$(DirSpec$, 16)
      If F$ = "" Then
         DirExist% = 0   'Doesnt exist
      Else
         DirExist% = -1  'It does exist
      End If
   Else
      DirExist% = 0       'Its a file, not a subdirectory
   End If
End If
End Function

Public Function encrypt$(a$)
On Error Resume Next
    x = 1
    For y = 1 To Len(a$)
       x = x + 1 ' x goes from 1 to 4
       If x = 5 Then x = 1
        B$ = B$ + Chr$((Asc(Mid$(a$, y, 1)) + x) + 127)
    Next y
    encrypt$ = B$
End Function

Public Function urlencode$(ByVal t$)
On Error Resume Next
                a$ = ""
                If Len(t$) Then
                    For y = 1 To Len(t$)
                    If InStr("&=", Mid$(t$, y, 1)) Then
                        a$ = a$ + Mid$(t$, y, 1)
                    Else
                        a$ = a$ + "%" + Hex$(Asc(Mid$(t$, y, 1)))
                    End If
                    
                    Next y
                End If
                urlencode$ = a$
End Function


Public Function Remove$(v1$, v2$)
On Error Resume Next
    ' remove V2 from V1
    If v2$ = "" Then GoTo EndRemoveFunction
    If v1$ = v2$ Then GoTo EndRemoveFunction
    vr$ = v1$
    Do
        If InStr(vr$, v2$) > 1 Then
        vr$ = Left$(vr$, InStr(vr$, v2$) - 1) + Mid$(vr$, InStr(vr$, v2$) + Len(v2$))
        End If
        
        If InStr(vr$, v2$) = 1 Then
        vr$ = Mid$(vr$, InStr(vr$, v2$) + Len(v2$))
        End If
    
    Loop While InStr(vr$, v2$) > 0
    
    Remove$ = vr$

EndRemoveFunction:

End Function

Public Function removeany$(v1$, v2$)
On Error Resume Next
    vr$ = ""
    For y = 1 To Len(v1$)
        vc$ = Mid$(v1$, y, 1)
        If InStr(v2$, vc$) = 0 Then
            vr$ = vr$ + vc$
        End If
    Next y
    removeany$ = vr$
End Function

Public Function replace$(Searchfor$, replacewith$, InThis$)
On Error Resume Next
    xInThis$ = InThis$
    x = InStr(xInThis$, Searchfor$)
    Do While x > 0
        xInThis$ = Left$(xInThis$, x - 1) + replacewith$ + Mid$(xInThis$, x + Len(Searchfor$))
        x = InStr(x + 1, xInThis$, Searchfor$)
    Loop
    replace$ = xInThis$
End Function


Public Function ReplaceAny$(Searchfor$, replacewith$, InThis$)
On Error Resume Next
    xInThis$ = InThis$
    For y = 1 To Len(Searchfor$)
        Do While InStr(xInThis$, Mid$(Searchfor$, y, 1))
            Mid(xInThis$, InStr(xInThis$, Mid$(Searchfor$, y, 1)), 1) = Mid$(replacewith$, y, 1)
        Loop
    Next y
    ReplaceAny$ = xInThis$
End Function
Public Function CheckDigit(RoutingNumber$)
On Error Resume Next
        Area$ = "CHECK DIGIT"
    xinvar$ = LTrim$(RTrim$(RoutingNumber$))
        rflag = 1
    If Len(xinvar$) > 9 Then
            xinvar$ = Left$(xinvar$, 9)
        End If

        If Len(xinvar$) = 9 Then
                digit = 1
                n1 = 0: n2 = 0
                Do While digit < 9
  n1 = n1 + (Val(Mid$(xinvar$, digit, 1)) * Val(Mid$("37137137", digit, 1)))
                    digit = digit + 1
                Loop
                n1 = n1 + Val(Mid$(xinvar$, 9, 1))
                If Right$(RTrim$(Str$(n1)), 1) = "0" Then
                        rflag = 0
                End If
        End If

        If rflag = 1 Then
        CheckDigit = 0
        Else
        CheckDigit = -1
        End If
End Function


' All of the following subroutines are necessary to perform the recursive
' descent parser.  CALC is the only callable routine, and must be passed
' a string containing a valid math expression.
' An invalid expression, such as (2**4) or (1+2+3+) will result in a
' SYNTAX ERROR message, printed on the screen by the sub PTV().  Mismatched
' parenthesis result in an error message displayed by sub LEVEL6().  These
' error messages could be replaced with the ERROR nn statement, allowing your
' own error-handling routines to report the error.
'
' This routine supports boolean expressions (1>2) and unary operators (5*-1)


Public Function Calc(ByVal a$)
On Error Resume Next
Debug.Print a$
TokenType = 0

'EVALUATE A$, Result!, ErrCode%
'Calc=Result!
'IF ErrCode% THEN ERROR 101
Area$ = "MATH PARSER"
R = 0
p = 1
If a$ = "" Then GoTo EndCalcSub
Arg$ = a$
Call GetExp(R)
Let Calc = R
EndCalcSub:
End Function
'
Public Function Arith(OO$, R, H) As Variant
On Error Resume Next
If OO$ = "-" Then R = (R - H)
If OO$ = "+" Then R = (R + H)
If OO$ = "*" Then R = (R * H)
If OO$ = "/" Then R = (R / H)
If OO$ = "^" Then R = (R ^ H)
If OO$ = "<" Then R = (R < H)
If OO$ = ">" Then R = (R > H)
If OO$ = "=" Then R = (R = H)
End Function

Sub GetExp(R)
On Error Resume Next
Call GetToken
Call Level1(R)
End Sub


Sub GetToken()
On Error Resume Next
Token$ = ""
While Mid$(Arg$, p, 1) = " ": p = p + 1: Wend
If InStr("-+*/^()<>=", Mid$(Arg$, p, 1)) Then TokenType = 1: Token$ = Mid$(Arg$, p, 1): p = p + 1: Exit Sub
If InStr("01234567890.", Mid$(Arg$, p, 1)) Then While InStr(" -+*/^()<>=", Mid$(Arg$, p, 1)) = 0: Token$ = Token$ + Mid$(Arg$, p, 1): p = p + 1: Wend: TokenType = 2
End Sub

Sub Level1(R)
On Error Resume Next
Call Level2(R): OO$ = Token$
While OO$ = "<" Or OO$ = ">" Or OO$ = "="
Call GetToken
Call Level2(H)
Call Arith(OO$, R, H)
OO$ = Token$
Wend
End Sub

Sub Level2(R)
On Error Resume Next
Call Level3(R)
OO$ = Token$
While OO$ = "+" Or OO$ = "-"
Call GetToken
Call Level3(H)
Call Arith(OO$, R, H)
OO$ = Token$
Wend
End Sub

Sub Level3(R)
On Error Resume Next
Call Level4(R)
OO$ = Token$
While OO$ = "*" Or OO$ = "/"
Call GetToken
Call Level4(H)
Call Arith(OO$, R, H)
OO$ = Token$
Wend
End Sub

Sub Level4(R)
On Error Resume Next
Call Level5(R)
If Token$ = "^" Then Call GetToken: Call Level4(H): Call Arith("^", R, H)
End Sub

Sub Level5(R)
On Error Resume Next
OO$ = ""
If TokenType = 1 And (Token$ = "+" Or Token$ = "-") Then OO$ = Token$: Call GetToken
Call Level6(R): If OO$ <> "" Then Call Un(OO$, R)
End Sub

Sub Level6(R)
On Error Resume Next
If Token$ = "(" And TokenType = 1 Then GoTo 230
Call Ptv(R): Exit Sub
230 Call GetToken
Call Level1(R)
If Token$ <> ")" Then Error 102
Call GetToken
End Sub

Sub Ptv(R)
On Error Resume Next
If TokenType = 2 Then R = Val(Token$): Call GetToken: Exit Sub
Error 101
End Sub

Sub Un(OO$, R)
On Error Resume Next
If OO$ = "-" Then R = -R
End Sub


Sub Push(a$)
On Error Resume Next
    If ArgStackPointer% < 32 Then
        ArgStackPointer% = ArgStackPointer% + 1
        ArgStack$(ArgStackPointer%) = a$
    End If
End Sub

Function Pop$()
On Error Resume Next
    If ArgStackPointer = 0 Then
        Pop$ = "%% STACK UNDERFLOW %%"
    Else
        Pop$ = ArgStack$(ArgStackPointer%)
        ArgStackPointer% = ArgStackPointer% - 1
    End If
End Function



' -----------------------------------Parse Routing Number---------------------------------------------


Public Function FindRoutingNo(micr As String, checkno As String) As String
On Error Resume Next
Dim C1 As String
C1 = micr
If InStr(C1, checkno) < 6 And InStr(C1, checkno) > 0 Then
C1 = Right(micr, Int(Len(micr) - (Len(checkno) + InStr(micr, checkno) - 1)))
End If
found = 0
For i = 1 To Int(Len(C1) - 9)

C2$ = Mid(C1, Int(i))
    If CheckDigit(C2$) = -1 Then
            If found < 1 Then
                FindRoutingNo = Left(C2$, 9)
            found = found + 1
        End If
    End If

Next

End Function


' ---------------------------------- Parse Check Number -------------------------------------------
    
Public Function SuspectCorrupt(micr As String, checkno As String) As String
On Error Resume Next
    If InStrRev(micr, checkno) = Int(Len(micr) - 2) Then
        If Left(Right(micr, 4), 1) = 0 Then
                SuspectCorrupt = "0" & checkno
            Else
                SuspectCorrupt = checkno
        End If
    End If
        If InStrRev(micr, checkno) = Int(Len(micr) - 3) Then
            SuspectCorrupt = checkno
        End If
End Function


Public Function FindCheckNo(micr As String, checkno As String) As String
On Error Resume Next
Dim checkresult As String

CheckNoLength = Len(checkno)
CKNOposition = InStr(micr, checkno)

' ------------------------------ Fix 2 Digit Check Numbers if Needed -------------------

If CheckNoLength = 2 Then
    If Not (CKNOposition = 10) And Not (CKNOposition = Int((Len(micr) - CheckNoLength) + 1)) Then
    checkno = "0" & checkno
    End If
End If

' ------------------------------ Locate and Identify Check Number ----------------------

' //The Check Number isn't in the MICR

If CKNOposition = 0 Then
checkresult = checkno
End If

' //Look for a centered Check Number w/errors

If CKNOposition = 11 And Not (Right(Left(micr, 10), 1) = 0) Then
    checkresult = SuspectCorrupt(micr, checkno)
End If

' //Check Number might be at the beginning look for error

If CKNOposition > 0 And CKNOposition < 6 Then
    Probable = Left(micr, Int((CKNOposition + CheckNoLength) - 1))
        If Int(Probable) <> Int(checkno) Then
        checkresult = SuspectCorrupt(micr, checkno)
        Else
        checkresult = Left(micr, Int((CKNOposition + CheckNoLength) - 1))
        End If
End If

' //Check Number is at the end. Look for a leading Zero

If CKNOposition = Int((Len(micr) - CheckNoLength) + 1) Then
    If CheckNoLength = 3 And Left(Right(micr, 4), 1) = 0 Then
        checkresult = "0" & checkno
        CheckNoLength = 4
    Else
        checkresult = checkno
        'CheckNoLength = 3
    End If

' //Check number is definately at the beginning

End If
If CKNOposition = 1 Then
checkresult = checkno
End If

' //Check Number is definately in the middle

If CKNOposition = 10 Then
checkresult = checkno
End If

' //Check Number is in the middle and needs a leading zero

If CKNOposition = 11 And Right(Left(micr, 10), 1) = 0 Then
    checkresult = "0" & checkno
End If

' //Check Number is in the middle and may need more that 1 leading zero. Check for error.

If CKNOposition > 11 And CKNOposition < Int(Len(micr) - 7) Then
    SearchStr = Mid(micr, 10)
    Crop = Left(SearchStr, Int((InStr(SearchStr, checkno) + CheckNoLength) - 1))
            If Int(Crop) <> Int(checkno) Then
            checkresult = SuspectCorrupt(micr, checkno)
            Else
            checkresult = Crop
        End If


    End If

FindCheckNo = checkresult
End Function


' ----------------------------------CheckDigit() for micr---------------------------------------


Public Function micrCheckDigit(micr As String) As String
On Error Resume Next
        Area = "CHECK DIGIT"
    xinvar = LTrim(RTrim(micr))
        rflag = 1
    If Len(xinvar) > 9 Then
            xinvar = Left(xinvar, 9)
        End If

        If Len(xinvar) = 9 Then
                digit = 1
                n1 = 0: n2 = 0
                Do While digit < 9
  n1 = n1 + Int(Mid(xinvar, digit, 1)) * Int(Mid("37137137", digit, 1))
                    digit = digit + 1
                Loop
                n1 = n1 + Int(Mid(xinvar, 9, 1))
                If Right(RTrim(CStr(n1)), 1) = "0" Then
                        rflag = 0
                End If
        End If

        If rflag = 1 Then
        micrCheckDigit = 0
        Else
        micrCheckDigit = -1
        End If
End Function




' ----------------------------------CheckDigit() for floating C2---------------------------------------


Public Function C2CheckDigit(C2 As String)
On Error Resume Next
        Area = "CHECK DIGIT"
    xinvar = LTrim(RTrim(C2))
        rflag = 1
    If Len(xinvar) > 9 Then
            xinvar = Left(xinvar, 9)
        End If

        If Len(xinvar) = 9 Then
                digit = 1
                n1 = 0: n2 = 0
                Do While digit < 9
  n1 = n1 + Int(Mid(xinvar, digit, 1)) * Int(Mid("37137137", digit, 1))
                    digit = digit + 1
                Loop
                n1 = n1 + Int(Mid(xinvar, 9, 1))
                If Right(RTrim(CStr(n1)), 1) = "0" Then
                        rflag = 0
                End If
        End If

        If rflag = 1 Then
        C2CheckDigit = 0
        Else
        C2CheckDigit = -1
        End If
End Function

Public Function findAccountNo(micr As String, checkno As String) As String
On Error Resume Next
' //Get Routing Number and Check Number w/any leading zeros
Dim rtn As String, chk As String
rtn = FindRoutingNo(micr, checkno)
chk = FindCheckNo(micr, checkno)

' //Find Account Number

If Left(micr, 9) = rtn And InStr(micr, chk) = 10 Then
findAccountNo = Right(micr, Int((Len(micr) - (Len(rtn) + Len(chk)))))
End If
If InStr(micr, chk) = 1 And InStr(micr, rtn) = Int(Len(chk) + 1) Then
findAccountNo = Right(micr, Int((Len(micr) - (Len(rtn) + Len(chk)))))
End If
If InStr(micr, rtn) = 1 And InStr(micr, chk) = Len(micr) - Len(chk) + 1 Then
findAccountNo = Left(Mid(micr, 10), Int(Len(micr) - ((Len(chk) + 9))))
End If
If InStr(micr, chk) = 0 And rtn Then
findAccountNo = Right(micr, Int(Len(micr) - 9))
End If
End Function



